<?php declare(strict_types=1);

namespace Infomaker\Everyware\Twig;

use Twig\Extension\ExtensionInterface;
use Twig\NodeVisitor\NodeVisitorInterface;
use Twig\RuntimeLoader\RuntimeLoaderInterface;
use Twig\TokenParser\TokenParserInterface;
use Twig\TwigFilter;
use Twig\TwigFunction;
use Twig\TwigTest;

/**
 * Interface TwigEnvironmentExtender
 * @package Infomaker\Everyware\Twig
 */
interface TwigExtendable
{
    public function addExtension(ExtensionInterface $extension);

    public function addFilter(TwigFilter $filter);

    public function addFunction(TwigFunction $function);

    public function addGlobal(string $name, $value);

    public function addNodeVisitor(NodeVisitorInterface $visitor);

    public function addRuntimeLoader(RuntimeLoaderInterface $loader);

    public function addTest(TwigTest $test);

    public function addTokenParser(TokenParserInterface $parser);

    public function hasExtension(string $class): bool;
}
